// Shader created with Shader Forge v1.13 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.13;sub:START;pass:START;ps:flbk:,lico:1,lgpr:1,nrmq:1,nrsp:0,limd:3,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,rprd:False,enco:False,rmgx:True,rpth:0,hqsc:True,hqlp:False,tesm:0,bsrc:0,bdst:1,culm:0,dpts:2,wrdp:True,dith:0,ufog:True,aust:True,igpj:False,qofs:0,qpre:1,rntp:1,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.5,fgcg:0.5,fgcb:0.5,fgca:1,fgde:0.01,fgrn:0,fgrf:300,ofsf:0,ofsu:0,f2p0:False;n:type:ShaderForge.SFN_Final,id:2579,x:33357,y:32728,varname:node_2579,prsc:2|diff-6518-OUT,spec-7149-OUT,gloss-705-OUT;n:type:ShaderForge.SFN_Tex2d,id:931,x:32155,y:32714,ptovrint:False,ptlb:Texture,ptin:_Texture,varname:node_931,prsc:2,tex:6f4480571a2f84a41954d4f492afe72e,ntxv:0,isnm:False|UVIN-5804-UVOUT;n:type:ShaderForge.SFN_Color,id:7219,x:32680,y:32461,ptovrint:False,ptlb:Color,ptin:_Color,varname:node_7219,prsc:2,glob:False,c1:0.7720588,c2:0.4655061,c3:0.4655061,c4:1;n:type:ShaderForge.SFN_Vector1,id:7955,x:32103,y:32970,varname:node_7955,prsc:2,v1:1;n:type:ShaderForge.SFN_If,id:8996,x:32434,y:32790,varname:node_8996,prsc:2|A-7955-OUT,B-7278-OUT,GT-931-R,EQ-931-G,LT-931-B;n:type:ShaderForge.SFN_ValueProperty,id:7278,x:32241,y:32928,ptovrint:False,ptlb:Channel,ptin:_Channel,varname:node_7278,prsc:2,glob:False,v1:0;n:type:ShaderForge.SFN_Vector1,id:705,x:33151,y:32819,varname:node_705,prsc:2,v1:0.5;n:type:ShaderForge.SFN_Vector1,id:7149,x:33151,y:32766,varname:node_7149,prsc:2,v1:0;n:type:ShaderForge.SFN_TexCoord,id:5804,x:31906,y:32678,varname:node_5804,prsc:2,uv:0;n:type:ShaderForge.SFN_Blend,id:6518,x:33032,y:32729,varname:node_6518,prsc:2,blmd:10,clmp:True|SRC-3596-OUT,DST-8293-OUT;n:type:ShaderForge.SFN_Color,id:1094,x:32680,y:32617,ptovrint:False,ptlb:Color2,ptin:_Color2,varname:_Color_copy,prsc:2,glob:False,c1:0.2735563,c2:0.5661765,c3:0.133218,c4:1;n:type:ShaderForge.SFN_Lerp,id:3596,x:32962,y:32579,varname:node_3596,prsc:2|A-7219-RGB,B-1094-RGB,T-3197-OUT;n:type:ShaderForge.SFN_FragmentPosition,id:6509,x:31553,y:33162,varname:node_6509,prsc:2;n:type:ShaderForge.SFN_Tex2d,id:3562,x:32257,y:33144,ptovrint:False,ptlb:Texture_copy,ptin:_Texture_copy,varname:_Texture_copy,prsc:2,tex:6f4480571a2f84a41954d4f492afe72e,ntxv:0,isnm:False|UVIN-9306-OUT;n:type:ShaderForge.SFN_If,id:4793,x:32484,y:33099,varname:node_4793,prsc:2|A-7955-OUT,B-7278-OUT,GT-3562-B,EQ-3562-R,LT-3562-G;n:type:ShaderForge.SFN_Power,id:3197,x:32729,y:32786,varname:node_3197,prsc:2|VAL-8996-OUT,EXP-8914-OUT;n:type:ShaderForge.SFN_Vector1,id:8914,x:32578,y:32858,varname:node_8914,prsc:2,v1:3;n:type:ShaderForge.SFN_ComponentMask,id:2243,x:31814,y:33156,varname:node_2243,prsc:2,cc1:0,cc2:1,cc3:-1,cc4:-1|IN-6509-XYZ;n:type:ShaderForge.SFN_Multiply,id:9306,x:32068,y:33185,varname:node_9306,prsc:2|A-2243-OUT,B-4336-OUT;n:type:ShaderForge.SFN_Vector1,id:4336,x:31901,y:33321,varname:node_4336,prsc:2,v1:0.2;n:type:ShaderForge.SFN_NormalVector,id:3691,x:31835,y:33411,prsc:2,pt:False;n:type:ShaderForge.SFN_ConstantClamp,id:2377,x:32678,y:33057,varname:node_2377,prsc:2,min:0.3,max:0.8|IN-4793-OUT;n:type:ShaderForge.SFN_ComponentMask,id:8222,x:32047,y:33398,varname:node_8222,prsc:2,cc1:0,cc2:-1,cc3:-1,cc4:-1|IN-3691-OUT;n:type:ShaderForge.SFN_Lerp,id:808,x:32877,y:33148,varname:node_808,prsc:2|A-2377-OUT,B-7610-OUT,T-8222-OUT;n:type:ShaderForge.SFN_Vector1,id:7610,x:32639,y:33210,varname:node_7610,prsc:2,v1:0.5;n:type:ShaderForge.SFN_Tex2d,id:2439,x:32258,y:33764,ptovrint:False,ptlb:Texture_copy_copy,ptin:_Texture_copy_copy,varname:_Texture_copy_copy,prsc:2,tex:6f4480571a2f84a41954d4f492afe72e,ntxv:0,isnm:False|UVIN-744-OUT;n:type:ShaderForge.SFN_If,id:8376,x:32485,y:33719,varname:node_8376,prsc:2|A-7955-OUT,B-7278-OUT,GT-2439-B,EQ-2439-R,LT-2439-G;n:type:ShaderForge.SFN_ComponentMask,id:3303,x:31815,y:33776,varname:node_3303,prsc:2,cc1:2,cc2:1,cc3:-1,cc4:-1|IN-6509-XYZ;n:type:ShaderForge.SFN_Multiply,id:744,x:32069,y:33804,varname:node_744,prsc:2|A-3303-OUT,B-276-OUT;n:type:ShaderForge.SFN_Vector1,id:276,x:31902,y:33940,varname:node_276,prsc:2,v1:0.2;n:type:ShaderForge.SFN_NormalVector,id:7767,x:31836,y:34030,prsc:2,pt:False;n:type:ShaderForge.SFN_ConstantClamp,id:1278,x:32679,y:33676,varname:node_1278,prsc:2,min:0.3,max:0.8|IN-8376-OUT;n:type:ShaderForge.SFN_ComponentMask,id:3958,x:32049,y:34028,varname:node_3958,prsc:2,cc1:2,cc2:-1,cc3:-1,cc4:-1|IN-7767-OUT;n:type:ShaderForge.SFN_Lerp,id:4399,x:32878,y:33768,varname:node_4399,prsc:2|A-1278-OUT,B-7590-OUT,T-1899-OUT;n:type:ShaderForge.SFN_Vector1,id:7590,x:32640,y:33830,varname:node_7590,prsc:2,v1:0.5;n:type:ShaderForge.SFN_Negate,id:2720,x:32317,y:34046,varname:node_2720,prsc:2|IN-3958-OUT;n:type:ShaderForge.SFN_Clamp01,id:1899,x:32503,y:34001,varname:node_1899,prsc:2|IN-2720-OUT;n:type:ShaderForge.SFN_Blend,id:8293,x:33081,y:33442,varname:node_8293,prsc:2,blmd:10,clmp:True|SRC-808-OUT,DST-4399-OUT;proporder:7219-931-7278-1094-3562-2439;pass:END;sub:END;*/

Shader "Shader Forge/Paintings" {
    Properties {
        _Color ("Color", Color) = (0.7720588,0.4655061,0.4655061,1)
        _Texture ("Texture", 2D) = "white" {}
        _Channel ("Channel", Float ) = 0
        _Color2 ("Color2", Color) = (0.2735563,0.5661765,0.133218,1)
        _Texture_copy ("Texture_copy", 2D) = "white" {}
        _Texture_copy_copy ("Texture_copy_copy", 2D) = "white" {}
    }
    SubShader {
        Tags {
            "RenderType"="Opaque"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdbase_fullshadows
            #pragma multi_compile_fog
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _Texture; uniform float4 _Texture_ST;
            uniform float4 _Color;
            uniform float _Channel;
            uniform float4 _Color2;
            uniform sampler2D _Texture_copy; uniform float4 _Texture_copy_ST;
            uniform sampler2D _Texture_copy_copy; uniform float4 _Texture_copy_copy_ST;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                LIGHTING_COORDS(3,4)
                UNITY_FOG_COORDS(5)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(_Object2World, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex);
                UNITY_TRANSFER_FOG(o,o.pos);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
/////// Vectors:
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
                float3 halfDirection = normalize(viewDirection+lightDirection);
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
                float Pi = 3.141592654;
                float InvPi = 0.31830988618;
///////// Gloss:
                float gloss = 0.5;
                float specPow = exp2( gloss * 10.0+1.0);
/////// GI Data:
                UnityLight light;
                #ifdef LIGHTMAP_OFF
                    light.color = lightColor;
                    light.dir = lightDirection;
                    light.ndotl = LambertTerm (normalDirection, light.dir);
                #else
                    light.color = half3(0.f, 0.f, 0.f);
                    light.ndotl = 0.0f;
                    light.dir = half3(0.f, 0.f, 0.f);
                #endif
                UnityGIInput d;
                d.light = light;
                d.worldPos = i.posWorld.xyz;
                d.worldViewDir = viewDirection;
                d.atten = attenuation;
                UnityGI gi = UnityGlobalIllumination (d, 1, gloss, normalDirection);
                lightDirection = gi.light.dir;
                lightColor = gi.light.color;
////// Specular:
                float NdotL = max(0, dot( normalDirection, lightDirection ));
                float LdotH = max(0.0,dot(lightDirection, halfDirection));
                float node_7955 = 1.0;
                float node_8996_if_leA = step(node_7955,_Channel);
                float node_8996_if_leB = step(_Channel,node_7955);
                float4 _Texture_var = tex2D(_Texture,TRANSFORM_TEX(i.uv0, _Texture));
                float node_8996 = lerp((node_8996_if_leA*_Texture_var.b)+(node_8996_if_leB*_Texture_var.r),_Texture_var.g,node_8996_if_leA*node_8996_if_leB);
                float node_4793_if_leA = step(node_7955,_Channel);
                float node_4793_if_leB = step(_Channel,node_7955);
                float2 node_9306 = (i.posWorld.rgb.rg*0.2);
                float4 _Texture_copy_var = tex2D(_Texture_copy,TRANSFORM_TEX(node_9306, _Texture_copy));
                float node_4793 = lerp((node_4793_if_leA*_Texture_copy_var.g)+(node_4793_if_leB*_Texture_copy_var.b),_Texture_copy_var.r,node_4793_if_leA*node_4793_if_leB);
                float node_8222 = i.normalDir.r;
                float node_8376_if_leA = step(node_7955,_Channel);
                float node_8376_if_leB = step(_Channel,node_7955);
                float2 node_744 = (i.posWorld.rgb.bg*0.2);
                float4 _Texture_copy_copy_var = tex2D(_Texture_copy_copy,TRANSFORM_TEX(node_744, _Texture_copy_copy));
                float node_3958 = i.normalDir.b;
                float3 diffuseColor = saturate(( saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) )) > 0.5 ? (1.0-(1.0-2.0*(saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) ))-0.5))*(1.0-lerp(_Color.rgb,_Color2.rgb,pow(node_8996,3.0)))) : (2.0*saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) ))*lerp(_Color.rgb,_Color2.rgb,pow(node_8996,3.0))) )); // Need this for specular when using metallic
                float specularMonochrome;
                float3 specularColor;
                diffuseColor = DiffuseAndSpecularFromMetallic( diffuseColor, 0.0, specularColor, specularMonochrome );
                specularMonochrome = 1-specularMonochrome;
                float NdotV = max(0.0,dot( normalDirection, viewDirection ));
                float NdotH = max(0.0,dot( normalDirection, halfDirection ));
                float VdotH = max(0.0,dot( viewDirection, halfDirection ));
                float visTerm = SmithBeckmannVisibilityTerm( NdotL, NdotV, 1.0-gloss );
                float normTerm = max(0.0, NDFBlinnPhongNormalizedTerm(NdotH, RoughnessToSpecPower(1.0-gloss)));
                float specularPBL = max(0, (NdotL*visTerm*normTerm) * unity_LightGammaCorrectionConsts_PIDiv4 );
                float3 directSpecular = (floor(attenuation) * _LightColor0.xyz) * pow(max(0,dot(halfDirection,normalDirection)),specPow)*specularPBL*lightColor*FresnelTerm(specularColor, LdotH);
                float3 specular = directSpecular;
/////// Diffuse:
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                half fd90 = 0.5 + 2 * LdotH * LdotH * (1-gloss);
                float3 directDiffuse = ((1 +(fd90 - 1)*pow((1.00001-NdotL), 5)) * (1 + (fd90 - 1)*pow((1.00001-NdotV), 5)) * NdotL) * attenColor;
                float3 indirectDiffuse = float3(0,0,0);
                indirectDiffuse += UNITY_LIGHTMODEL_AMBIENT.rgb; // Ambient Light
                float3 diffuse = (directDiffuse + indirectDiffuse) * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse + specular;
                fixed4 finalRGBA = fixed4(finalColor,1);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdadd_fullshadows
            #pragma multi_compile_fog
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _Texture; uniform float4 _Texture_ST;
            uniform float4 _Color;
            uniform float _Channel;
            uniform float4 _Color2;
            uniform sampler2D _Texture_copy; uniform float4 _Texture_copy_ST;
            uniform sampler2D _Texture_copy_copy; uniform float4 _Texture_copy_copy_ST;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                LIGHTING_COORDS(3,4)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(_Object2World, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
/////// Vectors:
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
                float3 halfDirection = normalize(viewDirection+lightDirection);
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
                float Pi = 3.141592654;
                float InvPi = 0.31830988618;
///////// Gloss:
                float gloss = 0.5;
                float specPow = exp2( gloss * 10.0+1.0);
////// Specular:
                float NdotL = max(0, dot( normalDirection, lightDirection ));
                float LdotH = max(0.0,dot(lightDirection, halfDirection));
                float node_7955 = 1.0;
                float node_8996_if_leA = step(node_7955,_Channel);
                float node_8996_if_leB = step(_Channel,node_7955);
                float4 _Texture_var = tex2D(_Texture,TRANSFORM_TEX(i.uv0, _Texture));
                float node_8996 = lerp((node_8996_if_leA*_Texture_var.b)+(node_8996_if_leB*_Texture_var.r),_Texture_var.g,node_8996_if_leA*node_8996_if_leB);
                float node_4793_if_leA = step(node_7955,_Channel);
                float node_4793_if_leB = step(_Channel,node_7955);
                float2 node_9306 = (i.posWorld.rgb.rg*0.2);
                float4 _Texture_copy_var = tex2D(_Texture_copy,TRANSFORM_TEX(node_9306, _Texture_copy));
                float node_4793 = lerp((node_4793_if_leA*_Texture_copy_var.g)+(node_4793_if_leB*_Texture_copy_var.b),_Texture_copy_var.r,node_4793_if_leA*node_4793_if_leB);
                float node_8222 = i.normalDir.r;
                float node_8376_if_leA = step(node_7955,_Channel);
                float node_8376_if_leB = step(_Channel,node_7955);
                float2 node_744 = (i.posWorld.rgb.bg*0.2);
                float4 _Texture_copy_copy_var = tex2D(_Texture_copy_copy,TRANSFORM_TEX(node_744, _Texture_copy_copy));
                float node_3958 = i.normalDir.b;
                float3 diffuseColor = saturate(( saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) )) > 0.5 ? (1.0-(1.0-2.0*(saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) ))-0.5))*(1.0-lerp(_Color.rgb,_Color2.rgb,pow(node_8996,3.0)))) : (2.0*saturate(( lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958))) > 0.5 ? (1.0-(1.0-2.0*(lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))-0.5))*(1.0-lerp(clamp(node_4793,0.3,0.8),0.5,node_8222))) : (2.0*lerp(clamp(lerp((node_8376_if_leA*_Texture_copy_copy_var.g)+(node_8376_if_leB*_Texture_copy_copy_var.b),_Texture_copy_copy_var.r,node_8376_if_leA*node_8376_if_leB),0.3,0.8),0.5,saturate((-1*node_3958)))*lerp(clamp(node_4793,0.3,0.8),0.5,node_8222)) ))*lerp(_Color.rgb,_Color2.rgb,pow(node_8996,3.0))) )); // Need this for specular when using metallic
                float specularMonochrome;
                float3 specularColor;
                diffuseColor = DiffuseAndSpecularFromMetallic( diffuseColor, 0.0, specularColor, specularMonochrome );
                specularMonochrome = 1-specularMonochrome;
                float NdotV = max(0.0,dot( normalDirection, viewDirection ));
                float NdotH = max(0.0,dot( normalDirection, halfDirection ));
                float VdotH = max(0.0,dot( viewDirection, halfDirection ));
                float visTerm = SmithBeckmannVisibilityTerm( NdotL, NdotV, 1.0-gloss );
                float normTerm = max(0.0, NDFBlinnPhongNormalizedTerm(NdotH, RoughnessToSpecPower(1.0-gloss)));
                float specularPBL = max(0, (NdotL*visTerm*normTerm) * unity_LightGammaCorrectionConsts_PIDiv4 );
                float3 directSpecular = attenColor * pow(max(0,dot(halfDirection,normalDirection)),specPow)*specularPBL*lightColor*FresnelTerm(specularColor, LdotH);
                float3 specular = directSpecular;
/////// Diffuse:
                NdotL = max(0.0,dot( normalDirection, lightDirection ));
                half fd90 = 0.5 + 2 * LdotH * LdotH * (1-gloss);
                float3 directDiffuse = ((1 +(fd90 - 1)*pow((1.00001-NdotL), 5)) * (1 + (fd90 - 1)*pow((1.00001-NdotV), 5)) * NdotL) * attenColor;
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse + specular;
                return fixed4(finalColor * 1,0);
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
