﻿using UnityEngine;
using System.Collections;

public class CameraFollow : MonoBehaviour {

	public GameObject player;
	public Vector3 followposition;
	private Vector3 followpoint;
	private Vector3 velocity = Vector3.zero;

	// Use this for initialization
	void Start () {
		followpoint = player.transform.position-transform.position + player.transform.forward*2f;
	}
	
	// Update is called once per frame
	void LateUpdate () {
		transform.position = player.transform.position + followposition;
		followpoint = Vector3.SmoothDamp( followpoint, player.transform.position-transform.position + player.transform.forward*2f, ref velocity, 0.5f );
		transform.rotation = Quaternion.LookRotation( followpoint );
	}
}
