﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PlayerReach : MonoBehaviour {

	private List<Collider> colliders = new List<Collider>();
	private PlayerController control;

	void Start() {
		control = transform.root.gameObject.GetComponent<PlayerController>();

	}

	void OnTriggerEnter( Collider col ) {

		if ( col.tag == "Artefact" ) {
			colliders.Add( col );
		}
	}

	void OnTriggerExit( Collider col ) {
		
		if ( col.tag == "Artefact" ) {
			colliders.Remove( col );
		}
	}

	void FixedUpdate() {
		if ( Input.GetButton( "Pickup" ) ) {
			if ( colliders.Count > 0 ) {
				colliders[0].gameObject.SetActive(false);
				control.PickedUpObjective( colliders[0].gameObject );
				colliders.RemoveAt(0);
			}
		}
	}
}
